Subject: Fixing lcov usage?

From: Luca Cirrottola <[email-masked]>
Date: Mon, 15 May 2023 14:10:41 +0200 (CEST)

Hello, 
I want use lcov to generate a coverage report for a C program, but I find out I always need to add "findutils" package to my shell in order for "lcov" to work. Shouldn't "findutils" be added to the propagated-inputs of "lcov", to have it available at runtime? 

Here is a short description of the problem which can be tested on the attached (empty) C program "main.c". 

1. The shell I want to use: 

guix shell -C gcc-toolchain lcov 

2. The commands I run in the shell: 

gcc -fprofile-arcs -ftest-coverage -g -O0 -c main.c 
gcc -fprofile-arcs -ftest-coverage -g -O0 -lgcov main.o -o my_program 
./my_program 
lcov --directory . --capture --output-file coverage.info 

3. The problem I get: lcov is unable to find the .gcda files for its coverage report (message ".geninfo-real: WARNING: no .gcda files found in . - skipping!"). 

Everything works fine with "guix shell -C gcc-toolchain lcov findutils", or if I add "findutils" to the propagated-inputs of "lcov" as in the proposed patch (for the commit 13e252af79ffb85bc68d8104fdf700269b903875 on master), which I have tested by defining and building the modified package in a local copy of the gnu/packages/code.scm module. 

Of coarse I am open to recognize my errors if I have missed something in the package usage :-) or if I have misunderstood the usage of propagated-inputs (but it didn't work with findutils as "normal" input)... or if there are better solutions. 

Thank you in advance, 
Luca 

-- 
Luca CIRROTTOLA 
Research software engineer @ INRIA - research center of the university of Bordeaux and Pau 
Personal webpage: [ https://lcirrottola.github.io/ | https://lcirrottola.github.io/ ] 
Tel: +33 5 2 4 57 41 21 
200 Avenue de la Vieille Tour 
33405 Talence cedex 
France 
diff --git a/gnu/packages/code.scm b/gnu/packages/code.scm
index d57954c47c..2b1d221122 100644
--- a/gnu/packages/code.scm
+++ b/gnu/packages/code.scm
@@ -580,6 +580,7 @@ stack traces.")
                  `("PERL5LIB" ":" prefix (,(getenv "PERL5LIB")))))
              #t)))))
     (inputs (list perl perl-io-compress perl-json))
+    (propagated-inputs (list findutils))
     (home-page "https://ltp.sourceforge.net/coverage/lcov.php")
     (synopsis "Code coverage tool that enhances GNU gcov")
     (description "LCOV is an extension of @command{gcov}, a tool part of the